'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var React = require('react');
var state = require('@codemirror/state');
var view = require('@codemirror/view');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

var _extends__default = /*#__PURE__*/_interopDefaultLegacy(_extends);
var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var React__namespace = /*#__PURE__*/_interopNamespace(React);

// credit: https://github.com/JakeGinnivan/merge-refs-hook

function setRefs(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref) {
    ref.current = value;
  }
}

function useMergeRefs(forwardedRef, localRef) {
  return React__default['default'].useCallback(value => {
    setRefs(forwardedRef, value);
    setRefs(localRef, value);
  }, [forwardedRef, localRef]);
}

var CodeMirror = /*#__PURE__*/React__namespace.forwardRef((_ref, ref) => {
  var value = _ref.value,
      onUpdate = _ref.onUpdate,
      _ref$extensions = _ref.extensions,
      passedExtensions = _ref$extensions === void 0 ? [] : _ref$extensions,
      elementProps = _ref.elementProps;
  var innerRef = React__namespace.useRef(null);
  var mergedRef = useMergeRefs(ref, innerRef);

  var _React$useState = React__namespace.useState(null),
      _React$useState2 = _slicedToArray__default['default'](_React$useState, 2);
      _React$useState2[0];
      var setEditorState = _React$useState2[1];

  var _React$useState3 = React__namespace.useState(null),
      _React$useState4 = _slicedToArray__default['default'](_React$useState3, 2),
      editorView = _React$useState4[0],
      setEditorView = _React$useState4[1];

  React__namespace.useEffect(() => {
    var currentEditor = innerRef.current;
    if (!currentEditor) return;
    var view$1;

    _asyncToGenerator__default['default']( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee() {
      var extensions, state$1;
      return _regeneratorRuntime__default['default'].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              extensions = [];
              if (onUpdate) extensions.push(view.EditorView.updateListener.of(onUpdate));
              state$1 = state.EditorState.create({
                doc: value,
                extensions: [...extensions, ...passedExtensions]
              });
              setEditorState(state$1);
              view$1 = new view.EditorView({
                state: state$1,
                parent: currentEditor
              });
              setEditorView(view$1);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();

    return () => {
      var _view;

      return (_view = view$1) === null || _view === void 0 ? void 0 : _view.destroy();
    };
  }, [innerRef, passedExtensions, onUpdate]);
  React__namespace.useEffect(() => {
    if (!editorView) return;
    var transaction = editorView.state.update({
      changes: {
        from: 0,
        to: editorView.state.doc.length,
        insert: value
      }
    });
    editorView.dispatch(transaction);
  }, [value]);
  return /*#__PURE__*/React__namespace.createElement("div", _extends__default['default']({
    ref: mergedRef
  }, elementProps));
});
CodeMirror.displayName = 'CodeMirror';

module.exports = CodeMirror;
